%define nightly @NIGHTLY_VERSION@%{nil}
%define _sysconfdir %{_prefix}/etc
%define release 1
%define configure_opts GSL_LIBS="-lgsl"

%if "%{?nightly:%{nightly}}%{!?nightly:0}" == "%{nil}"
%undefine nightly
%endif

# borrowed from python3-rpm-macros
%define pyYdir %{_builddir}/pythonY-%{name}-%{version}-%{release}

# -- metadata ---------------

Name: @PACKAGE@
Version: @BASE_VERSION@
Release: %{?nightly:0.%{nightly}}%{!?nightly:%{release}}%{?dist}
Summary: LSC Algorithm Inspiral Library
License: GPLv2+
Group: LAL
Source0: http://software.ligo.org/lscsoft/source/lalsuite/%{name}-%{version}%{?nightly:-%{nightly}}.tar.xz
URL: https://wiki.ligo.org/Computing/LALSuite
Packager: Adam Mercer <adam.mercer@ligo.org>
Prefix: %{_prefix}

# -- build requirements -----

# C
BuildRequires: gcc
BuildRequires: gcc-c++
BuildRequires: gsl-devel
BuildRequires: help2man >= 1.37
BuildRequires: liblal-devel >= @MIN_LAL_VERSION@
BuildRequires: liblalframe-devel >= @MIN_LALFRAME_VERSION@
BuildRequires: liblalmetaio-devel >= @MIN_LALMETAIO_VERSION@
BuildRequires: liblalsimulation-devel >= @MIN_LALSIMULATION_VERSION@
BuildRequires: liblalburst-devel >= @MIN_LALBURST_VERSION@
BuildRequires: libmetaio-devel
BuildRequires: make
BuildRequires: pkgconfig >= 0.18.0

# swig
BuildRequires: swig >= @MIN_SWIG_VERSION@

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# python2
BuildRequires: python2-rpm-macros
BuildRequires: python
BuildRequires: python-devel
BuildRequires: python2-glue
BuildRequires: python2-lal >= @MIN_LAL_VERSION@
BuildRequires: python2-lalframe >= @MIN_LALFRAME_VERSION@
BuildRequires: python2-lalmetaio >= @MIN_LALMETAIO_VERSION@
BuildRequires: python2-lalsimulation >= @MIN_LALSIMULATION_VERSION@
BuildRequires: python2-lalburst >= @MIN_LALBURST_VERSION@
BuildRequires: python2-ligo-lw
BuildRequires: python2-mock
BuildRequires: python2-numpy >= @MIN_NUMPY_VERSION@
BuildRequires: python-pathlib
BuildRequires: pytest
BuildRequires: rsync
%endif

# python3x
BuildRequires: python-srpm-macros
BuildRequires: python3-rpm-macros
BuildRequires: epel-rpm-macros
BuildRequires: python%{python3_pkgversion}
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-glue
BuildRequires: python%{python3_pkgversion}-lal >= @MIN_LAL_VERSION@
BuildRequires: python%{python3_pkgversion}-lalframe >= @MIN_LALFRAME_VERSION@
BuildRequires: python%{python3_pkgversion}-lalmetaio >= @MIN_LALMETAIO_VERSION@
BuildRequires: python%{python3_pkgversion}-lalsimulation >= @MIN_LALSIMULATION_VERSION@
BuildRequires: python%{python3_pkgversion}-lalburst >= @MIN_LALBURST_VERSION@
BuildRequires: python%{python3_pkgversion}-ligo-lw
BuildRequires: python%{python3_pkgversion}-numpy >= @MIN_NUMPY_VERSION@
BuildRequires: python%{python3_pkgversion}-pytest

# octave
BuildRequires: octave-devel
BuildRequires: lal-octave >= @MIN_LAL_VERSION@
BuildRequires: lalframe-octave >= @MIN_LALFRAME_VERSION@
BuildRequires: lalmetaio-octave >= @MIN_LALMETAIO_VERSION@
BuildRequires: lalsimulation-octave >= @MIN_LALSIMULATION_VERSION@
BuildRequires: lalburst-octave >= @MIN_LALBURST_VERSION@

# -- packages ---------------

# lalinspiral
Summary: LSC Algorithm Inspiral Library
Requires: lib%{name} = %{version}-%{release}
Requires: python%{python3_pkgversion}-%{name} = %{version}-%{release}
%description
The LSC Algorithm Inspiral Library for gravitational wave data analysis.
This package provides the runtime tools.

# liblalinspiral
%package -n lib%{name}
Summary: LSC Algorithm Inspiral Library - library package
Requires: gsl
Requires: libmetaio
Requires: liblal >= @MIN_LAL_VERSION@
Requires: liblalframe >= @MIN_LALFRAME_VERSION@
Requires: liblalmetaio >= @MIN_LALMETAIO_VERSION@
Requires: liblalsimulation >= @MIN_LALSIMULATION_VERSION@
Conflicts: %{name} <= 2.0.0-1
%description -n lib%{name}
The LSC Algorithm Inspiral Library for gravitational wave data analysis.
This package contains the shared-object libraries needed to run applications
that use the LAL Inspiral library.

# liblalinspiral-devel
%package -n lib%{name}-devel
Summary: Files and documentation needed for compiling programs that use LAL Inspiral
Group: LAL
Requires: lib%{name} = %{version}-%{release}
Requires: gsl-devel
Requires: liblal-devel >= @MIN_LAL_VERSION@
Requires: liblalframe-devel >= @MIN_LALFRAME_VERSION@
Requires: liblalmetaio-devel >= @MIN_LALMETAIO_VERSION@
Requires: liblalsimulation-devel >= @MIN_LALSIMULATION_VERSION@
Requires: libmetaio-devel
Provides: %{name}-devel = %{version}-%{release}
Obsoletes: %{name}-devel < %{version}-%{release}
%description -n lib%{name}-devel
The LSC Algorithm Inspiral Library for gravitational wave data analysis.
This package contains files needed build applications that use the LAL Inspiral
library.

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# python2-lalinspiral
%package -n python2-%{name}
Summary: Python %{python2_version} bindings for LALInspiral
Group: LAL
Requires: lib%{name} = %{version}-%{release}
Requires: python
Requires: python2-glue
Requires: python2-lal >= @MIN_LAL_VERSION@
Requires: python2-lalburst
Requires: python2-lalframe >= @MIN_LALFRAME_VERSION@
Requires: python2-lalmetaio >= @MIN_LALMETAIO_VERSION@
Requires: python2-lalsimulation >= @MIN_LALSIMULATION_VERSION@
Requires: python2-lalburst >= @MIN_LALBURST_VERSION@
Requires: python2-ligo-lw
Requires: python2-numpy >= @MIN_NUMPY_VERSION@
Provides: %{name}-python = %{version}-%{release}
Provides: deprecated()
Obsoletes: %{name}-python < %{version}-%{release}
%{?python_provide:%python_provide python2-%{name}}
%description -n python2-%{name}
This package provides the Python %{python2_version} bindings for LALInspiral.
%endif

# python3x-lalinspiral
%package -n python%{python3_pkgversion}-%{name}
Summary: Python %{python3_version} bindings for LALInspiral
Group: LAL
Requires: lib%{name} = %{version}-%{release}
Requires: python%{python3_pkgversion}
Requires: python%{python3_pkgversion}-glue
Requires: python%{python3_pkgversion}-lal >= @MIN_LAL_VERSION@
Requires: python%{python3_pkgversion}-lalburst
Requires: python%{python3_pkgversion}-lalframe >= @MIN_LALFRAME_VERSION@
Requires: python%{python3_pkgversion}-lalmetaio >= @MIN_LALMETAIO_VERSION@
Requires: python%{python3_pkgversion}-lalsimulation >= @MIN_LALSIMULATION_VERSION@
Requires: python%{python3_pkgversion}-lalburst >= @MIN_LALBURST_VERSION@
Requires: python%{python3_pkgversion}-ligo-lw
Requires: python%{python3_pkgversion}-numpy >= @MIN_NUMPY_VERSION@
%{?python_provide:%python_provide python%{python3_pkgversion}-%{name}}
%description -n python%{python3_pkgversion}-%{name}
This package provides the Python bindings for LALInspiral.

# lalinspiral-octave
%package octave
Summary: Octave bindings for LALInspiral
Group: LAL
Requires: lib%{name} = %{version}-%{release}
Requires: octave
Requires: lal-octave >= @MIN_LAL_VERSION@
Requires: lalframe-octave >= @MIN_LALFRAME_VERSION@
Requires: lalmetaio-octave >= @MIN_LALMETAIO_VERSION@
Requires: lalsimulation-octave >= @MIN_LALSIMULATION_VERSION@
%description octave
This package provides the Octave bindings for LALInspiral.

# -- build stages -----------

%prep
%setup -q -n %{name}-%{version}%{?nightly:-%{nightly}}

%build
# build C library with python3
%configure %{configure_opts} --disable-gcc-flags --enable-swig PYTHON=%{__python3}
%{__make} %{?_smp_mflags} V=1

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# build python2 library (copy things so we don't have to rebuild them)
rm -rf %pyYdir
rsync -ra . %pyYdir
pushd %pyYdir
rm -rfv python/%{name}/*.{la,lo,o} python/%{name}/.libs
%configure %{configure_opts} --disable-doxygen --disable-gcc-flags --disable-swig-octave --enable-swig-python PYTHON=%{__python2}
%{__make} V=1 -C swig
%{__make} V=1 -C python/%{name}
%{__make} V=1 -C bin bin_PROGRAMS="" dist_bin_SCRIPTS=""
popd
%endif

%check
# C + python3 + octave
%{__make} %{?_smp_mflags} V=1 VERBOSE=1 check

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# python2
[ -d %pyYdir/test/python ] && %{__make} %{?_smp_mflags} V=1 VERBOSE=1 -C %pyYdir -C test/python check
%endif

%install
# C + python3 + octave
%make_install

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# python2
%{__make} -C %pyYdir -C swig install-exec-am DESTDIR=%{?buildroot}
%{__make} -C %pyYdir -C python/%{name} install DESTDIR=%{?buildroot}
%endif

find $RPM_BUILD_ROOT%{_libdir} -name '*.la' -delete

%post
ldconfig

%postun
ldconfig

%clean
[ ${RPM_BUILD_ROOT} != "/" ] && rm -Rf ${RPM_BUILD_ROOT}
rm -Rf ${RPM_BUILD_DIR}/%{name}-%{version}%{?nightly:-%{nightly}}

# -- files ------------------

%files -n lib%{name}
%defattr(-,root,root)
%license COPYING
%{_libdir}/*.so.*

%files -n lib%{name}-devel
%defattr(-,root,root)
%license COPYING
%{_includedir}/lal
%{_libdir}/*.a
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
%files -n python2-%{name}
%defattr(-,root,root)
%license COPYING
%{python2_sitearch}/*
%endif

%files -n python%{python3_pkgversion}-%{name}
%defattr(-,root,root)
%license COPYING
%{python3_sitearch}/*

%files octave
%defattr(-,root,root)
%license COPYING
%{_prefix}/lib*/octave/*/site/oct/*/lalinspiral.oct*

%files
%defattr(-,root,root)
%license COPYING
%{_bindir}/*
%{_mandir}/man1/*
%{_sysconfdir}/*

# -- changelog --------------

# dates should be formatted using: 'date +"%a %b %d %Y"'
%changelog
* Mon Jan 11 2021 Adam Mercer <adam.mercer@ligo.org> 2.0.1-1
- Update for 2.0.1

* Wed Oct 28 2020 Adam Mercer <adam.mercer@ligo.org> 2.0.0-1
- Update for 2.0.0

* Mon Jun 08 2020 Adam Mercer <adam.mercer@ligo.org> 1.10.1-1
- Update for 1.10.1

* Mon Dec 09 2019 Adam Mercer <adam.mercer@ligo.org> 1.10.0-2
- Packaging updates

* Tue Nov 26 2019 Adam Mercer <adam.mercer@ligo.org> 1.10.0-1
- O3b release

* Thu May 23 2019 Adam Mercer <adam.mercer@ligo.org> 1.9.0-1
- O3 release

* Mon Feb 25 2019 Adam Mercer <adam.mercer@ligo.org> 1.8.1-1
- ER14 release

* Thu Sep 13 2018 Adam Mercer <adam.mercer@ligo.org> 1.8.0-1
- Pre O3 release

* Tue Feb 07 2017 Adam Mercer <adam.mercer@ligo.org> 1.7.7-1
- O2 release

* Mon Sep 26 2016 Adam Mercer <adam.mercer@ligo.org> 1.7.6-1
- ER10 release

* Thu Jun 23 2016 Adam Mercer <adam.mercer@ligo.org> 1.7.5-1
- ER9 release

* Fri Mar 25 2016 Adam Mercer <adam.mercer@ligo.org> 1.7.4-1
- Pre O2 packaging test release
